%global winever 4.12.1-2%{?dist}

%global debug_package %{nil}

Name:           wine-dxvk
Version:        1.3.1
Release:        1%{?dist}
Summary:        Vulkan-based D3D11 and D3D10 implementation for Linux / Wine

License:        zlib
URL:            https://github.com/doitsujin/dxvk
Source0:        %{url}/archive/v%{version}/dxvk-%{version}.tar.gz

BuildRequires:  gcc
BuildRequires:  gcc-c++
BuildRequires:  glslang
BuildRequires:  meson
BuildRequires:  wine-devel

Requires:       wine = %{winever}
Requires:       wine-dxvk-dxgi%{?_isa} = %{version}-%{release}
Requires:       vulkan-loader%{?_isa}

Provides:       wine-d3d10%{?_isa} = %{winever}
Provides:       wine-d3d11%{?_isa} = %{winever}
Conflicts:      wine-wined3d-d3d10%{?_isa} = %{winever}
Conflicts:      wine-wined3d-d3d11%{?_isa} = %{winever}

ExclusiveArch:  %{ix86} x86_64

%description
%{summary}

%package dxgi
Summary:        DXVK DXGI implementation

Provides:       wine-dxgi%{?_isa} = %{winever}
Conflicts:      wine-wined3d-dxgi%{?_isa} = %{winever}

%description dxgi
%{summary}

%prep
%setup -q -n dxvk-%{version}

%build
%ifarch x86_64
/usr/bin/meson --buildtype=plain --wrap-mode=nodownload --auto-features=enabled . x86_64-redhat-linux-gnu \
--cross-file build-wine64.txt --buildtype release --prefix /builddir/build/BUILD/dxvk-%{version}/build.w64
%else
/usr/bin/meson --buildtype=plain --wrap-mode=nodownload --auto-features=enabled . i686-redhat-linux-gnu \
--cross-file build-wine32.txt --buildtype release --prefix /builddir/build/BUILD/dxvk-%{version}/build.w32
%endif
%meson_build

%install
%meson_install

%ifarch x86_64
mkdir -p %{buildroot}%{_libdir}/wine/
install -p -m 755 %buildroot/builddir/build/BUILD/dxvk-%{version}/build.w64/lib/dxgi.dll.so %{buildroot}%{_libdir}/wine/
install -p -m 755 %buildroot/builddir/build/BUILD/dxvk-%{version}/build.w64/lib/d3d10.dll.so %{buildroot}%{_libdir}/wine/
install -p -m 755 %buildroot/builddir/build/BUILD/dxvk-%{version}/build.w64/lib/d3d10core.dll.so %{buildroot}%{_libdir}/wine/
install -p -m 755 %buildroot/builddir/build/BUILD/dxvk-%{version}/build.w64/lib/d3d10_1.dll.so %{buildroot}%{_libdir}/wine/
install -p -m 755 %buildroot/builddir/build/BUILD/dxvk-%{version}/build.w64/lib/d3d11.dll.so %{buildroot}%{_libdir}/wine/
rm -rf %buildroot/builddir/build/BUILD/dxvk-%{version}/build.w64/lib/
%else
mkdir -p %{buildroot}%{_libdir}/wine/
install -p -m 755 %buildroot/builddir/build/BUILD/dxvk-%{version}/build.w32/lib/dxgi.dll.so %{buildroot}%{_libdir}/wine/
install -p -m 755 %buildroot/builddir/build/BUILD/dxvk-%{version}/build.w32/lib/d3d10.dll.so %{buildroot}%{_libdir}/wine/
install -p -m 755 %buildroot/builddir/build/BUILD/dxvk-%{version}/build.w32/lib/d3d10core.dll.so %{buildroot}%{_libdir}/wine/
install -p -m 755 %buildroot/builddir/build/BUILD/dxvk-%{version}/build.w32/lib/d3d10_1.dll.so %{buildroot}%{_libdir}/wine/
install -p -m 755 %buildroot/builddir/build/BUILD/dxvk-%{version}/build.w32/lib/d3d11.dll.so %{buildroot}%{_libdir}/wine/
rm -rf %buildroot/builddir/build/BUILD/dxvk-%{version}/build.w32/lib/
%endif

%files
%license LICENSE
%doc README.md
%{_libdir}/wine/d3d10.dll.so
%{_libdir}/wine/d3d10_1.dll.so
%{_libdir}/wine/d3d10core.dll.so
%{_libdir}/wine/d3d11.dll.so

%files dxgi
%license LICENSE
%{_libdir}/wine/dxgi.dll.so


%changelog
* Thu Jul 25 2019 Frantisek Zatloukal <fzatlouk@redhat.com> - 1.3.1-1
- Initial packaging

